package edu.cmu.cs.distributed.intro.ex02;

import java.util.ArrayList;
import java.util.List;

public class ArrayStack<T> implements Stack<T> {
	protected final List<T> list;
	
	public ArrayStack() {
		list = new ArrayList<T>();
	}

	@Override
	public void push(T val) {
		list.add(val);
	}

	@Override
	public T pop() {
		return list.remove(list.size()-1);
	}

	@Override
	public T peek() {
		return list.get(list.size()-1);
	}
}
