package edu.cmu.cs.distributed.intro.ex04;

import java.io.File;
import java.io.IOException;

public class Exceptions {
	public static void main(String[] args) {
		File myFile = new File("foo.txt");
		
		try {
			String path = myFile.getCanonicalPath();
			System.out.println("My file is at " + path);
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		try {
			String foo = null;
			foo.length();
		} catch(NullPointerException e) {
			System.out.println("It's null!");
		}
	}
	
	public static void doFileStuff(File file) throws IOException {
		file.createNewFile();
	}
}
